<script setup>
import { HttpError } from '@/helpers/HttpError'
import { useThemeStore } from '@/stores/ThemeStore'
import { useLocaleStore } from '@/stores/LocaleStore'
import { useDialogStore } from '@/stores/DialogStore'
import { useAppStore, SignInStateType } from '@/stores/AppStore'
import DialogBox from '@/layouts/DialogBox.vue'
import PageHeader from '@/layouts/PageHeader.vue'
import PageFooter from '@/layouts/PageFooter.vue'
</script>


<script>
export default {

	props: {
		title: String,  // text to display title
		fit: Boolean,   // fit or has margin around page
	},

	data() {
		const element = document.querySelector('meta[name="error"]')
		const error = element ? JSON.parse(element.getAttribute('content')) : null
		return {
			appStore: useAppStore(),
			error,
			items: [
				{ key: 'home' },
				{ key: 'members' },
				{ key: 'changeIcon' },
				{ key: 'changeName' },
				{ key: 'changePass' },
				{ key: 'quit' },
			],
		}
	},

	methods: {
		onClick(e, key) {
			switch (key) {
				case 'home':
					this.$router.push({ name: 'home' })
					break
				case 'members':
					//this.$router.push({ name: 'members' })
					window.location.href = '/members'
					break
				case 'changeIcon':
					this.$router.push({ name: 'changeIcon' })
					break
				case 'changeName':
					this.$router.push({ name: 'changeName' })
					break
				case 'changePass':
					this.$router.push({ name: 'changePass' })
					break
				case 'quit':
					window.location.href = '/signout'
					break
			}
		}
	},

	mounted() {
		const dialogStore = useDialogStore()
		dialogStore.box = this.$refs.box

		// reloads locale
		const localeStore = useLocaleStore()
		localeStore.setup()
		//if (this.appStore.member)
		//localeStore.change(this.appStore.member.locale)

		// reloads theme
		const themeStore = useThemeStore()
		themeStore.setup()
	},

	i18n: {
		messages: {
			en: {
				home: "Home",
				members: "Members",
				changeIcon: "Change Icon",
				changeName: "Change Name",
				changePass: "Change Password",
				quit: "Sign-out",
			},
			th: {
				home: "เริ่มต้น",
				members: "สมาชิก",
				changeIcon: "เปลี่อน Icon",
				changeName: "เปลี่ยนชื่อ",
				changePass: "เปลี่ยนรหัสผ่าน",
				quit: "ออกจากระบบ",
			},
		},
	},

}
</script>


<template>
	<DialogBox ref="box">
		<div id="app-inner">
			<PageHeader :title="title" />

			<div id="app-body">
				<aside v-if="appStore.state === SignInStateType.AlreadySignIn" id="app-side">
					<div style="margin: 1rem">
						<img :width="80" :height="80" :src="appStore.icon"
							:alt="appStore.member ? appStore.member.email : ''"
							:title="appStore.member ? appStore.member.name : ''" /><br />
						<br />

						<div v-for="item in items">
							<a href="#" @click.prevent="(e) => onClick(e, item.key)">{{ $t(item.key) }}</a>
						</div>
					</div>
				</aside>

				<main id="app-page" :style="{ margin: fit ? '0' : '2rem' }">
					<div :hidden="!error" id="error-panel" :style="{ margin: fit ? '0' : '2rem' }">
						<span>{{ error ? HttpError.get(error, $t, $i18n.locale) : '' }}</span>
					</div>
					<slot></slot>
				</main>
			</div>

			<PageFooter />
		</div>
	</DialogBox>
</template>


<style scoped>
#app-inner {
	display: flex;
	flex-flow: column nowrap;
	align-items: stretch;
	height: 100%;
	min-height: 100%;
}

#app-body {
	display: flex;
	flex: 1 0;
	flex-wrap: wrap;
	align-items: stretch;
}

#app-side {
	flex: 0 0 200px;
	background-color: var(--c-secondary);
}

#app-side a {
	display: block;
	padding: 0.5rem;
	text-decoration: solid;
	color: var(--c-page-color-1);
}

#app-side a:hover {
	background: #eee;
	color: #000;
}

#app-page {
	flex: 1 0;
}

#error-panel {
	padding: 1rem;
	border: 2px solid red;
	border-radius: 1rem;
	background: #c66;
}

#error-panel span {
	color: #fff;
}
</style>
